#!/usr/bin/perl
# carp.pl

use Carp qw(croak);

divide(1, 2);
divide(3, 4);
divide(4);
divide(5, 7);

sub divide {
    my( $numerator, $denominator ) = @_;
    croak q(Can't divide by zero!) if $denominator == 0;
    $numerator / $denominator;
    }